

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.jbpm.runtime.manager.impl.RuntimeEnvironmentBuilder;
import org.jbpm.services.task.identity.JBossUserGroupCallbackImpl;
import org.kie.api.io.ResourceType;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.manager.RuntimeManagerFactory;
import org.kie.api.runtime.process.ProcessInstance;
import org.kie.internal.io.ResourceFactory;
import org.kie.internal.runtime.manager.RuntimeEnvironment;
import org.kie.internal.runtime.manager.context.EmptyContext;
import org.kie.internal.task.api.UserGroupCallback;

import bitronix.tm.resource.jdbc.PoolingDataSource;

public class StandAloneProcessStart {
	private static EntityManagerFactory emf;

	public static void main(String[] args) throws Exception {
		RuntimeManager manager = getRuntimeManager("Evaluation2.bpmn");
		RuntimeEngine engine = manager.getRuntimeEngine(EmptyContext.get());
		KieSession ksession = engine.getKieSession();

		// start a new process instance
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("employee", "krisv");
		params.put("reason", "Yearly performance evaluation");
		ProcessInstance processInstance = ksession.startProcess(
				"com.sample.evaluation", params);
		System.out.println("Start Evaluation process "
				+ processInstance.getId());}
	
	 private static RuntimeManager getRuntimeManager(String process) {
	        setupDataSource();

	        Properties properties = new Properties();
	        properties.setProperty("krisv", "");
	        properties.setProperty("mary", "");
	        properties.setProperty("john", "");
	        UserGroupCallback userGroupCallback = new JBossUserGroupCallbackImpl(properties);

	        emf = Persistence.createEntityManagerFactory("org.jbpm.persistence.jpa");

	        RuntimeEnvironment environment =
	                RuntimeEnvironmentBuilder.getDefault()
	                .persistence(true)
	                .entityManagerFactory(emf)
	                .userGroupCallback(userGroupCallback)
	                .addAsset(ResourceFactory.newClassPathResource(process), ResourceType.BPMN2)
	                .get();
	        return RuntimeManagerFactory.Factory.get().newPerProcessInstanceRuntimeManager(environment);

	    }

	    public static PoolingDataSource setupDataSource() {
	        // Please edit here when you want to use your database
	        PoolingDataSource pds = new PoolingDataSource();
	        pds.setUniqueName("jdbc/jbpm-ds");
	        pds.setClassName("bitronix.tm.resource.jdbc.lrc.LrcXADataSource");
	        pds.setMaxPoolSize(5);
	        pds.setAllowLocalTransactions(true);
	        pds.getDriverProperties().put("user", "jbpm");
	        pds.getDriverProperties().put("password", "jbpm");
	        pds.getDriverProperties().put("url", "jdbc:mysql://localhost:3306/jbpm");
	        pds.getDriverProperties().put("driverClassName", "com.mysql.jdbc.Driver");
	        pds.init();
	        return pds;
	    }
	
}