import java.util.HashMap;
import java.util.Properties;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.jbpm.runtime.manager.impl.RuntimeEnvironmentBuilder;
import org.jbpm.services.task.identity.JBossUserGroupCallbackImpl;
import org.kie.api.io.ResourceType;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.manager.RuntimeManagerFactory;
import org.kie.internal.io.ResourceFactory;
import org.kie.internal.runtime.manager.RuntimeEnvironment;
import org.kie.internal.runtime.manager.context.EmptyContext;
import org.kie.internal.task.api.InternalTaskService;
import org.kie.internal.task.api.UserGroupCallback;

import bitronix.tm.resource.jdbc.PoolingDataSource;


public class StandAloneTasks2 {
	
	static long taskId1 = 115;
	static long taskId2 = 114;
	private static EntityManagerFactory emf;

	public static void main(String[] args) throws Exception {
		RuntimeManager manager = getRuntimeManager("Evaluation2.bpmn");
        RuntimeEngine runtime = manager.getRuntimeEngine(EmptyContext.get());
        
		InternalTaskService taskService = (InternalTaskService) runtime
				.getTaskService();
			
			System.out.println("'john' completing task " + taskId1);
			taskService.start(taskId1, "john");
			HashMap results = new HashMap<String, Object>();
			results.put("performance", "acceptable");
			taskService.complete(taskId1, "john", results);
			


			System.out.println("'mary' completing task " +taskId2);
			taskService.start(taskId2, "mary");
			results = new HashMap<String, Object>();
			results.put("performance", "outstanding");
			taskService.complete(taskId2, "mary", results);
			
			System.out.println("Process instance completed");
	}
	
	private static RuntimeManager getRuntimeManager(String process) {
        setupDataSource();

        Properties properties = new Properties();
        properties.setProperty("krisv", "");
        properties.setProperty("mary", "");
        properties.setProperty("john", "");
        UserGroupCallback userGroupCallback = new JBossUserGroupCallbackImpl(properties);

        emf = Persistence.createEntityManagerFactory("org.jbpm.persistence.jpa");

        RuntimeEnvironment environment =
                RuntimeEnvironmentBuilder.getDefault()
                .persistence(true)
                .entityManagerFactory(emf)
                .userGroupCallback(userGroupCallback)
                .addAsset(ResourceFactory.newClassPathResource(process), ResourceType.BPMN2)
                .get();
        return RuntimeManagerFactory.Factory.get().newPerProcessInstanceRuntimeManager(environment);

    }

    public static PoolingDataSource setupDataSource() {
        // Please edit here when you want to use your database
        PoolingDataSource pds = new PoolingDataSource();
        pds.setUniqueName("jdbc/jbpm-ds");
        pds.setClassName("bitronix.tm.resource.jdbc.lrc.LrcXADataSource");
        pds.setMaxPoolSize(5);
        pds.setAllowLocalTransactions(true);
        pds.getDriverProperties().put("user", "jbpm");
        pds.getDriverProperties().put("password", "jbpm");
        pds.getDriverProperties().put("url", "jdbc:mysql://localhost:3306/jbpm");
        pds.getDriverProperties().put("driverClassName", "com.mysql.jdbc.Driver");
        pds.init();
        return pds;
    }
}